<?php
/*
* Module Payments2Carriers v 0.1 for PrestaShop 1.5.0.17, 1.5.1.0, 1.5.2.0
*
* 2012 SHOPDESIGN4U
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author SHOPDESIGN4U
*  @copyright SHOPDESIGN4U
*  @version Release: $Revision: 1 $
*  @license http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  Module based on shiptopay
*/

class Payments2Carriers extends Module{
    
	function __construct(){
		$this->name = 'payments2carriers';
		$this->tab = 'payments';
		$this->version = '0.1';
		$this->author = 'SHOPDESIGN4U';

		parent::__construct();

		$this->page = basename(__FILE__, '.php');
		$this->displayName = $this->l('Payments to carriers');
		$this->description = $this->l('Assign payment methods to carriers (PrestaShop 1.5)');
	}

	function install(){
		if (!parent::install()){
			return false;
		}
        
       $this->moveOverriteFiles();
        
        Db::getInstance(_PS_USE_SQL_SLAVE_)->Execute('CREATE TABLE `'._DB_PREFIX_.'payments2carriers` (
            `id_carrier` INT( 11 ) NOT NULL,
            `id_payment` INT( 11 ) NOT NULL
            ) ENGINE = MYISAM');
        
		return true;
	}
	public function uninstall(){
		
		if (!parent::uninstall()){
			return false;
			}
            
        Db::getInstance(_PS_USE_SQL_SLAVE_)->Execute('DROP TABLE '._DB_PREFIX_.'payments2carriers');
		Configuration::deleteByName('CARRIERPAYMENTS_ACTIVE');
        
		return true;	
			
	}
	
	private function moveOverriteFiles()
	{
		if(!copy(dirname(__FILE__).'/override/classes/Hook.php',_PS_ROOT_DIR_ .'/override/classes/Hook.php'))
				return false;
		return true;
	}
    
	function getContent(){
		
		$output = '<h2>'.$this->displayName.' (v. '.$this->version.')</h2>
        <p>'.$this->description.'</p>';
		
        if(!file_exists('../override/classes/Hook.php')){
            $output .= '<h2 style="color:red;">'.$this->l('The module is not properly installed!').'</h2>';
            $output .= '<h3 style="color:red;">'.$this->l('Move file').' <b style="color: black;">'.__PS_BASE_URI__.'modules/payments2carriers/overide/classes/Hook.php</b> '.$this->l('to').' <b style="color: black;">'.__PS_BASE_URI__.'override/classes/module/</b></h2>';
        }
        
		if(Tools::isSubmit('saveSetup')){
		  
            $data = $_POST['data'];
            
            Configuration::updateValue('CARRIERPAYMENTS_ACTIVE', $_POST['CARRIERPAYMENTS_ACTIVE']);
            
            if(count($data)){
                
                Db::getInstance(_PS_USE_SQL_SLAVE_)->Execute('TRUNCATE TABLE '._DB_PREFIX_.'payments2carriers');
                
                foreach($data as $carrier => $payments){
                    if(count($payments)){
                        foreach($payments as $payment => $val){
                            if($val == 1 && $carrier && $payment){
                                Db::getInstance(_PS_USE_SQL_SLAVE_)->Execute('INSERT INTO '._DB_PREFIX_.'payments2carriers VALUES ('.intval($carrier).', '.intval($payment).')');
                            }
                        }
                    }
                }
            }
		}
        
		$output .= $this->infoForm();
		return $output;
	}

	function infoForm(){
	   
		global $cookie;
        $output = '';
    	$carr = $this->getCarriers($cookie->id_lang,1, false, false);
    	$pay = $this->getPayment();
    	
    	$output .= '<fieldset><legend>'.$this->l('Settings').'</legend>
		<ul class="listapayments2carriers">
        <form method="post" action="'.Tools::htmlentitiesUTF8($_SERVER['REQUEST_URI']).'"" >';         

		$output .= '<label>'.$this->l('Enabled module').'</label>
        <div class="margin-form">
			<input type="radio" value="1" id="CARRIERPAYMENTS_ACTIVE_on" name="CARRIERPAYMENTS_ACTIVE" '.(Configuration::get('CARRIERPAYMENTS_ACTIVE')==1 ? 'checked="checked"' : '').'>
			<label for="CARRIERPAYMENTS_ACTIVE_on" class="t"> <img title="'.$this->l('Yes').'" alt="'.$this->l('Yes').'" src="../img/admin/enabled.gif"></label>
			<input type="radio" value="0" id="CARRIERPAYMENTS_ACTIVE_off" name="CARRIERPAYMENTS_ACTIVE" '.(Configuration::get('CARRIERPAYMENTS_ACTIVE')!=1 ? 'checked="checked"' : '').'>
			<label for="CARRIERPAYMENTS_ACTIVE_off" class="t"> <img title="'.$this->l('No').'" alt="'.$this->l('No').'" src="../img/admin/disabled.gif"></label>
            <p>'.$this->l('If you disable the module, all payments will be made available regardless of the setting.').'</p>
        </div>
        
        <hr />';

        $output .= '<table cellspacing="0" cellpadding="0" class="table">';
        
        $output .= '<tr>';
        $output .= '<th>'.$this->l('Carriers').'</th>';
    	foreach($pay as $pk => $payment){
    	   if(file_exists('../modules/'.$payment['pay_name'].'/logo.gif'))
                $output .= '<th><img src="'.__PS_BASE_URI__.'modules/'.$payment['pay_name'].'/logo.gif" title="'.$payment['name'].'" alt="'.$payment['pay_name'].'" /></th>';
    	   else
                $output .= '<th>'.$payment['pay_name'].'</th>';
        }
        $output .= '</tr>';
        
    	foreach($carr as $ck => $carrier){
    	   	$output .= '<tr '.($ck%2 == 1 ? 'class="alt_row"' : '').'>';
            $output .= '<td>'.$carrier['name'].'</td>';
            
        	foreach($pay as $pk => $payment){
        	   $checked = Db::getInstance()->ExecuteS('SELECT * FROM `'._DB_PREFIX_.'payments2carriers` WHERE id_carrier = '.intval($carrier['id_carrier']).' AND id_payment = '.intval($payment['id_module'])) ? true : false;
        	   $output .= '<td style="text-align: center;"><input type="checkbox" name="data['.$carrier['id_carrier'].']['.$payment['id_module'].']" value="1" '.($checked ? 'checked="checked"' : '').' /></td>';
        	}
            
            $output .= '</tr>';
    	}
        
        $output .= '</table><br />';        
    	$output.= '<input type="submit" class="button pointer" name="saveSetup" value="'.$this->l('Update').'" />
        </form></fieldset>';
        
    	return $output;
	
	}
    
	public static function getCarriers($id_lang, $active = false, $delete = false, $id_zone = false){
	   
	 	if (!Validate::isBool($active))
	 		die(Tools::displayError());
		$sql = '
			SELECT c.*, cl.delay
			FROM `'._DB_PREFIX_.'carrier` c
			LEFT JOIN `'._DB_PREFIX_.'carrier_lang` cl ON (c.`id_carrier` = cl.`id_carrier` AND cl.`id_lang` = '.$id_lang.')
			LEFT JOIN `'._DB_PREFIX_.'carrier_zone` cz  ON (cz.`id_carrier` = c.`id_carrier`)'.
			($id_zone ? 'LEFT JOIN `'._DB_PREFIX_.'zone` z  ON (z.`id_zone` = '.$id_zone.')' : '').'
			WHERE c.`deleted` '.($delete ? '= 1' : ' = 0').
			($active ? ' AND c.`active` = 1' : '').
			($id_zone ? ' AND cz.`id_zone` = '.$id_zone.'
			AND z.`active` = 1' : '').'
			GROUP BY c.`id_carrier`';
		$carriers = Db::getInstance()->ExecuteS($sql);
		foreach ($carriers as $key => $carrier)
			if ($carrier['name'] == '0')
				$carriers[$key]['name'] = Configuration::get('PS_SHOP_NAME');
		return $carriers;
	}
    
	public static function getPayment(){
	 	$payments = Db::getInstance()->ExecuteS('
    		SELECT *, m.name as pay_name
    		FROM `'._DB_PREFIX_.'module` m
    		LEFT JOIN `'._DB_PREFIX_.'hook_module` hm ON m.`id_module` = hm.`id_module`
    		LEFT JOIN `'._DB_PREFIX_.'hook` k ON hm.`id_hook` = k.`id_hook`
    		WHERE k.`position` = 1 AND k.id_hook = 1');
		
		foreach ($payments as $k => $paymod){
			if(file_exists(_PS_MODULE_DIR_.'/'.$paymod['pay_name'].'/'.$paymod['pay_name'].'.php'))
            {
                require_once(_PS_MODULE_DIR_.'/'.$paymod['pay_name'].'/'.$paymod['pay_name'].'.php');
                $module = get_object_vars(Module::getInstanceByName($paymod['pay_name']));
    			$payments[$k]['name'] = $module['displayName']; 
            }
		}
        
		return $payments;
	}
}
